﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace prvi
{
   public  class Aranzman : IPopust
    {
       private string pocetnaDestinacija;
       private string krajnjaDestinacija;
       private bool lastMinute;
       private int brojNOcenja;
       private double cenaNocenja;
       private List<Karta> listakarata;

       public string PocetnaDestinacija { get { return this.pocetnaDestinacija; } }
       public string KrajnjaDestinacija { get { return this.krajnjaDestinacija; } }

       public Aranzman(string poc,string kraj,bool lm,int brnoc,double cenaNO)
       {
           this.pocetnaDestinacija = poc;
           this.krajnjaDestinacija = kraj;
           this.lastMinute = lm;
           this.brojNOcenja = brnoc;
           this.cenaNocenja = cenaNO;
           listakarata = new List<Karta>();
       }

       public void dodajKarte(List<Karta> lista)
       {
           Karta poc = lista[0];
           Karta kraj = lista[lista.Count];

           if (pocetnaDestinacija != poc.PocetnaDestinacija)
           {
               
              GreskaAranzman g= new GreskaAranzman(poc, "LOsa pocetka karta");
              g.ToString();
           }
           if(krajnjaDestinacija != kraj.KrajnjaDestinacija)
           {
               GreskaAranzman g = new GreskaAranzman(poc, "LOsa krajnja karta");
               g.ToString();
           }

           if (pocetnaDestinacija == poc.PocetnaDestinacija && krajnjaDestinacija != kraj.KrajnjaDestinacija)
           {
               this.listakarata = lista;
           }
           
       
       }

       public double CenaAranzmana {

           get 
           {
               if (lastMinute == true)
                   return Popust;

               double x = 0;

               x += cenaNocenja * brojNOcenja;

               foreach (Karta item in listakarata)
               {
                   x += item.dajCenuKarte();
               }

               return x;
           }
       
       
       }



        public double Popust
        {
            get 
            {
                double x = 0;

                x += cenaNocenja * brojNOcenja - (cenaNocenja * brojNOcenja * 0.3);

                foreach (Karta item in listakarata)
                {
                    if (item is IPopust)
                    {
                       IPopust p = item as IPopust;

                       //x += item.Popust;
                    }
                    else
                    {
                        x+=item.dajCenuKarte();
                    }
                }

                return x;
            
            }
        }

        public override string ToString()
        {
           // foreach
            return "";
        }
    }
}
