﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace IIKolokvijum
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        BinarnoStablo<Student> stablo;
        List<Student> lista;

        public MainWindow()
        {
            InitializeComponent();
            txtMax.Text = "15";
            stablo = new BinarnoStablo<Student>();
           lista = new List<Student>();
        }

        private void btnDodaj_Click(object sender, RoutedEventArgs e)
        {
            Student s=null;
            try
            {
                int index = Int32.Parse(txtIndex.Text);
                int upis = Int32.Parse(txtGodina.Text);
                DateTime datum = dpDatum.SelectedDate.Value;
                Double poeni = Double.Parse(txtPoeni.Text);

                s = new Student(index, upis, txtIme.Text, datum);
                s.BrojPoena = poeni;
                stablo.Dodaj(s);
              
                lista.Add(s);

                lbPrikaz.Items.Clear();

                foreach (Student item in lista)
                {
                    lbPrikaz.Items.Add(item.ToString());
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("Nepravilan unos");
            }
            
           
           
        }

        private void btnPrikaz_Click(object sender, RoutedEventArgs e)
        {
           
            try
            {
                int n = Int32.Parse(txtRedni.Text);
                Student s = stablo[n];

                lblInforamcija.Content = s.ToString();
            }
            catch (Exception ex)
            {
                MessageBox.Show("Nema po zadatom kriterijumu");
            }
        }

        private void btnPrikaz2_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                lbKriterijum.Items.Clear();
                List<Student> list = null;
                lista = stablo.lista();
                double broj = Int32.Parse(txtMax.Text);
                double max = broj / 2;
                Student s = new Student();
                s.BrojPoena = max;
                DateTime datum1 = DateTime.Parse("1/1/1991");
                DateTime datum2 = DateTime.Parse("1/1/1992");
                if (cbKriterijum.SelectedIndex == 0)
                {
                    
                        if (list != null)
                        foreach (Student item in list)
                        {
                            lbKriterijum.Items.Clear();
                            if (item.CompareTo(s) == 1)
                            {
                                lbKriterijum.Items.Add(item);
                            }
                        }
                    else MessageBox.Show("Nema studenata u stablu");
                }

                else if (cbKriterijum.SelectedIndex == 1)
                {
                    if (list != null)
                        foreach (Student item in list)
                        {
                            lbKriterijum.Items.Clear();
                            if (item.CompareTo(s) == 1 && (item.DatumRodjenja.Year.Equals(datum1.Year) || item.DatumRodjenja.Year.Equals(datum2.Year)))
                            {
                                lbKriterijum.Items.Add(item);
                            }
                        }
                    else MessageBox.Show("Nemaju studenta u stablu");
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }
        


    }
}
