﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Filip_Radovanovic_73_12
{

    public partial class MainWindow : Window
    {

        public bool uslov(Student student)
        {
            int max = Convert.ToInt32(tbMax.Text);

            DateTime datum = student.DatumRodjenja;

            if ( (student.BrojPoena > max / 2) && (datum.Year == 1991 || datum.Year == 1992))
                return true;
                
            return false;
        }

        BinarnoStablo<Student> stablo;

        List<Student> pomocnaLista = new List<Student>();

        public MainWindow()
        {
            InitializeComponent();

            stablo = new BinarnoStablo<Student>();
            tbMax.Text = "15";

            Student s1 = new Student(1, 2012, "Pera Peric", new DateTime(1991,1,1));
            s1.BrojPoena = 20;

            stablo.dodajVrednost(s1);
            //
            Student s2 = new Student(17, 2012, "Mika Lazic", new DateTime(1993, 1, 1));
            s2.BrojPoena = 13;

            stablo.dodajVrednost(s2);

            //
            Student s3 = new Student(15, 2012, "Joca Jecic", new DateTime(1993, 1, 1));
            s3.BrojPoena = 12;
            stablo.dodajVrednost(s3);
            //

            Student s4 = new Student(15, 2012, "Mikisa", new DateTime(1992, 1, 1));
            s4.BrojPoena = 12;
            stablo.dodajVrednost(s4);

            cbUslov.Items.Add("Studenti koji imaju vise od pola poena u odnosu na maximum u rastucem poretku");
            cbUslov.Items.Add("Studenti 1992. ili 1991. godiste koji imaju vise od pola poena u odnosu na maximum u opadajucem poretku");
            refreshStudent();
        }

        private void btn_Dodaj(object sender, RoutedEventArgs e)
        {
            
            string ime;
            int indeks;
            int godinaUpisa;
            DateTime godinaRodjenja;
            int brojPoena;

            try
            {
                ime = tbIme.Text;
                indeks = Convert.ToInt32(tbIndeks.Text);
                godinaUpisa = Convert.ToInt32(tbGodina.Text);
                godinaRodjenja = Convert.ToDateTime(dpDatum.SelectedDate);
                brojPoena = Convert.ToInt32(tbPoeni.Text);

            }
            catch (Exception)
            {
                MessageBox.Show("Unesite sve podatke (ispravno)", "Los unos!");
                return;
                throw;
            }
            

            Student student = new Student(indeks, godinaUpisa, ime, godinaRodjenja);
            student.BrojPoena = brojPoena;

            stablo.dodajVrednost(student);

            refreshStudent();
        }

        public void refreshStudent()
        {
            lvStudenti.Items.Clear();

            foreach (Student s in stablo.VratiEnumeratorPremaSelekciji(x => x.BrojPoena > -1))
            {
                lvStudenti.Items.Add(s);
            }
        }

        private void comboBox1_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            int max;

            try
            {
                max = Convert.ToInt32(tbMax.Text);
            }
            catch (Exception)
            {
                if(cbUslov.SelectedIndex != -1)
                    MessageBox.Show("Unesite maximalan broj poena", "Los unos!");
                cbUslov.SelectedIndex = -1;

                return;
                throw;
            }

            lvRang.Items.Clear();

            pomocnaLista.Clear();

            if (cbUslov.SelectedIndex == 0)
            {
                foreach (Student s in stablo.VratiEnumeratorPremaSelekciji(x => x.BrojPoena > max / 2))
                {
                    lvRang.Items.Add(s);
                    pomocnaLista.Add(s);
                }
            }
            else
                if (cbUslov.SelectedIndex == 1)
                {
                    foreach (Student s in stablo.VratiEnumeratorPremaSelekciji(uslov))
                    {
                        pomocnaLista.Add(s);
                    }

                    pomocnaLista.Sort();

                    foreach (Student s in pomocnaLista)
                    {
                        lvRang.Items.Add(s);
                    }
                }
        }

        private void btnPrikazi_Click(object sender, RoutedEventArgs e)
        {
            int index;

            try
            {
                index = Convert.ToInt32(tbRangIndex.Text) - 1;

                labelStudent.Content = pomocnaLista[index];
            }
            catch (Exception)
            {
                return;
                throw;
            }

        }
        
    }
}
