﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace drugiPopravni
{
    public class Student:IComparable<Student>,IEquatable<Student>
    {
        protected int index;
        public int Index
        {
            get
            {
                return index;
            }
        }

        protected int godinaUpisa;

        public int GodinaUpisa
        {
            get
            {
                return godinaUpisa;
            }
        }

        protected string imeIPrezime;

        public string ImeIPrezime
        {
            get
            {
                return imeIPrezime;
            }
        }

        protected DateTime datumRodjenja;

        public DateTime DatumRodjenja
        {
            get
            {
                return datumRodjenja;
            }
        }

        protected double brojPoena;

        public double BrojPoena
        {
            get
            {
                return brojPoena;
            }
            set
            {
                brojPoena = value;
            }
        }

        public Student(int index, int upisan, string ime, DateTime datum)
        {
            this.index = index;
            this.godinaUpisa = upisan;
            this.imeIPrezime = ime;
            this.datumRodjenja = datum;
        }

        public override string ToString()
        {
            return ImeIPrezime+": "+DatumRodjenja.ToString()+", "+this.Index+"/"+this.GodinaUpisa+", "+this.BrojPoena;
        }

        public int CompareTo(Student other)
        {
            if (this.BrojPoena > other.BrojPoena) return 1;
            else if (this.BrojPoena < other.BrojPoena) return -1;
            else return 0;
        }

        public bool Equals(Student other)
        {
            if (this.Index == other.Index && this.GodinaUpisa == other.GodinaUpisa) return true;
            else return false;
        }
    }
}
