﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace prviPopravni
{
    public class Aranzman:IPopust
    {
        private string pocetnaDestinacija;
        private string krajnjaDestinacija;
        private bool lastMinute;
        private int brojNocenja;
        private double cenaNocenja;
        protected List<Karta> karte;
        public string PocetnaDestinacija
        {
            get
            {
                return pocetnaDestinacija;
            }
        }
        public string KrajnjaDestinacija
        {
            get
            {
                return krajnjaDestinacija;
            }
        }

        public Aranzman(string poc, string kraj, int brn, double cena, bool lm)
        {
            this.pocetnaDestinacija = poc;
            this.krajnjaDestinacija = kraj;
            this.lastMinute = lm;
            this.brojNocenja = brn;
            this.cenaNocenja = cena;
        }

        public void DodajKartu(List<Karta> karta)
        {
            if (karta[0].PocetnaDestinacija != this.pocetnaDestinacija)
                throw new GreskaAranzmana(karta[0], "Pocetne destinacije se ne slazu");
            if(karta[karta.Count-1].KrajnjaDestinacija!=this.krajnjaDestinacija)
                throw new GreskaAranzmana(karta[karta.Count - 1], "Pocetne destinacije se ne slazu");
            this.karte = karta;
        }

        public double CenaAranzmana
        {
            get
            {
                double cena=0;
                foreach (Karta k in karte)
                    cena += k.dajCenuKarte();
                return cena + cenaNocenja * brojNocenja;
            }
        }

        public double Popust
        {
            get
            {
                double popust = 0;
                IPopust p;
                foreach (Karta k in karte)
                {
                    p = k as IPopust;
                    if (p != null)
                        popust += p.Popust;
                }
                if (lastMinute)
                    return popust+cenaNocenja*brojNocenja * 0.3;
                else
                    return popust;
            }
        }
        public override string ToString()
        {
            string s = "Aranzman: "+this.pocetnaDestinacija+" - "+this.krajnjaDestinacija+"\n";
            foreach (Karta k in karte)
                s += k.ToString() + "\n";
            return s;
        }
    }
}
