﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PrviKolokvijum
{
    public class Putovanje : IPopust
    {
        private string pocetnaDestinacija;
        private string krajnjaDestinacija;
        protected List<Aranzman> aranzmani;

        public Putovanje(string pocetna, string krajnja)
        {
            this.pocetnaDestinacija = pocetna;
            this.krajnjaDestinacija = krajnja;
            aranzmani = new List<Aranzman>();
        }

        public void dodajAranzmane(List<Aranzman> a)
        {

            Aranzman pocetni = a.First<Aranzman>();
            Aranzman krajnji = a.Last<Aranzman>();
            foreach (Aranzman item in a)
            {

                try
                {
                    if (!pocetni.PocetnaDestinacija.Equals(this.pocetnaDestinacija))
                    {
                        aranzmani.Add(item);
                    }
                    else
                        try
                        {
                            throw new GreskaPutovanja(item, "Pocetna destinacija nije ista!");
                        }
                        catch { }
                }
                catch (GreskaAranzmana ga)
                {

                    throw new GreskaPutovanja(item, "Pocetna destinacija nije ista!");
                }

                try
                {
                    if (!krajnji.KrajnjaDestinacija.Equals(this.krajnjaDestinacija))
                    {
                        aranzmani.Add(item);
                    }
                    else try
                        {
                            throw new GreskaPutovanja(item, "Krajnja destinacija nije ista!");
                        }
                        catch { }
                }
                catch (GreskaAranzmana ga)
                {
                    Console.WriteLine(ga.ToString());
                }
                   /* if (pocetni.PocetnaDestinacija.Equals(this.pocetnaDestinacija))
                    {
                        
                    }
                    else
                        throw new GreskaPutovanja(item, "Pocetne destinacije nisu iste!");
                
                    if (krajnji.KrajnjaDestinacija.Equals(this.krajnjaDestinacija))
                    {
                        
                    }
                    else
                        throw new GreskaPutovanja(item, "Krajnje destinacije nisu iste!");*/
                

                aranzmani.Add(item);
            }
        }

        public double CenaPutovanja
        {
            get
            {
                double cena = 0;
                foreach (Aranzman item in aranzmani)
                {
                    cena += item.CenaAranzmana;
                }

                return cena;
            }
        }

        public double Popust
        {
            get 
            {
                double popust = 0;

                foreach (Aranzman item in aranzmani)
                {
                    popust += item.Popust;
                }

                return popust;
            }
        }

        public override string ToString()
        {
            string poruka = "Putovanje:" + this.pocetnaDestinacija + "->" + this.krajnjaDestinacija + "\n";

            foreach (Aranzman item in aranzmani)
            {
                poruka += item.ToString();
            }

            return poruka;
        }
    }
}
