﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PrviKol
{
    public class Putovanje : IPopust
    {
        private string pocetnaDestinacija;
        private string krajnjaDestinacija;

        public Putovanje(string pd, string kd)
        {
            this.pocetnaDestinacija = pd;
            this.krajnjaDestinacija = kd;

        }

        protected List<Aranzman> listaAranzmana;

        public void dodajAranzmane(List<Aranzman> lista)
        {
            if (lista.First().PocetanaDestinacija != pocetnaDestinacija)
                throw new GreskaPutovanja(lista.First(), "Ne poklapa se prvi");
            else if (lista.Last().Krajnjadestinacija != krajnjaDestinacija)
                throw new GreskaPutovanja(lista.Last(), "Ne poklapa se poslednji");
            else
            {
                listaAranzmana = lista;
            }
        }
        public double CenaPutovanja 
        {
            get
            {
                double cena = 0.0;
                foreach (Aranzman a in listaAranzmana)
                {
                    cena += a.CenaAranzmana;
                }
                return cena;
            }
        }

        public double Popust
        {
            get 
            {
                double cena = 0.0;
                foreach (Aranzman a in listaAranzmana)
                {
                    cena += a.Popust;
                }
                return cena;
            }
        }
        public override string ToString()
        {
            string s = "Putovanje:" + pocetnaDestinacija + "->" + krajnjaDestinacija;
            foreach (Aranzman a in listaAranzmana)
            {
                s += a.ToString();
            }
            return s;
        }
    }
}
