﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace TreciKol
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        RezultatiDataContext rdc;
        String idUtakmice;
        string id;
        public MainWindow()
        {
            InitializeComponent();
            lvLista.SelectedValuePath = "IDUtakmice";
            rdc = new RezultatiDataContext();
            popuniTabelu();
            
        }

        private void popuniTabelu()
        {
            var utakmice = from u in rdc.Utakmicas
                           join e1 in rdc.Ekipas
                           on u.IDEkipeDomacina equals e1.ID
                           join e2 in rdc.Ekipas
                           on u.IDEkipeGosta equals e2.ID
                           orderby u.PocetakUtakmice
                           select new { ID = u.ID, IDDomacina = e1.ID, Domacin = e1.Naziv, IDGosta = e2.ID, Gost = e2.Naziv, Pocetak = u.PocetakUtakmice, Kraj = u.KrajUtakmice};
            string minut;
            int domacin;
            int gost;


            foreach (var item in utakmice)
            {
                minut = kojeJeVreme(item.Pocetak,DateTime.Now);
                domacin = kolikoGolovaDomacin(item.IDDomacina);
                gost = kolikoGolovaGost(item.IDGosta);
                lvLista.Items.Add(new { Domacin = item.Domacin, Gost = item.Gost, Minut = minut, IDUtakmice = item.ID });
            }

            
        }
        string kojeJeVreme(DateTime pocetak, DateTime trenutnoVreme)
        {
            string s = "";
            double razlika = (trenutnoVreme.Subtract(pocetak)).TotalMinutes;
            if (razlika < 0)
                s = "mec nije poceo";
            else if (razlika > 45 && razlika < 60)
                s = "poluvreme";
            else if (razlika >= 60 && razlika <= 90)
            {
                razlika -= 15;
                s = (int)razlika + "'";
            }
            else if (razlika > 0 && razlika <= 45)
                s = (int)razlika + "'";
            else if (razlika > 90)
                s = "kraj";
            return s;
        }
        int kolikoGolovaDomacin(int Id)
        {
            var golovi = from u in rdc.Utakmicas
                         join gol in rdc.Gols
                         on u.ID equals gol.IDUtakmice
                         where u.IDEkipeDomacina == Id && gol.VremeGola <= DateTime.Now
                         group u by u.IDEkipeDomacina;
            int koliko = 0;
            //int koliko = golovi.Sum(golovi.
            return koliko;
        }
        int kolikoGolovaGost(int Id)
        {
            var golovi = from u in rdc.Utakmicas
                         join gol in rdc.Gols
                         on u.ID equals gol.IDUtakmice
                         where u.IDEkipeDomacina == Id && gol.VremeGola <= DateTime.Now
                         group u by u.IDEkipeDomacina;
            int koliko = 0;
            // koliko = golovi.Sum(golovi.
            return koliko;
        }

        private void dodajGol(object sender, MouseButtonEventArgs e)
        {
            string ID = lvLista.SelectedValue.ToString();

            
            //string vreme = lvLista.SelectedValuePath = "Minut";
            //vreme = vreme.ToString();
            DodavanjeGolova dg = new DodavanjeGolova(rdc, int.Parse(ID) );
            dg.Show();
        }

        private void MenuItem_Click(object sender, RoutedEventArgs e)
        {

        }
    }
}
