﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Drugi
{
    class Student : IComparable
    {
        protected int indeks;
        protected int godinaUpisa;
        protected string imeIPrezime;
        protected DateTime datumRodjenja;
        protected double brojPoena;

        public int Indeks { get { return this.indeks; } }
        public int GodinaUpisa { get { return this.godinaUpisa; } }
        public string ImeIPrezime { get { return this.imeIPrezime; } }
        public DateTime DatumRodjenja { get { return this.datumRodjenja; } }
        public double BrojPoena { get { return this.brojPoena; } set { this.brojPoena = value; } }

        public Student(int indeks, int godUpisa, string ime, DateTime datRodj)
        {
            this.indeks = indeks;
            this.godinaUpisa = godUpisa;
            this.imeIPrezime = ime;
            this.datumRodjenja = datRodj;
        }

        public override string ToString()
        {
            return this.imeIPrezime + ": " + this.datumRodjenja.Day + "." + this.datumRodjenja.Month + "." + this.datumRodjenja.Year + ", " + this.indeks + "/" + this.godinaUpisa + ", broj poena=" + this.brojPoena;
        }

        public int CompareTo(Object obj)
        {
            Student s = (Student)obj;

            if (s.brojPoena > this.brojPoena)
            {
                return 1;
            }
            else if (s.brojPoena < this.brojPoena)
            {
                return -1;
            }
            else
            {
                return 0;
            }
        }
    }
}
