﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Prvi
{
    class Aranzman : IPopust
    {
        private string pocetnaDestinacija;
        private string krajnjaDestinacija;
        private int brNocenja;
        private double cenaNocenja;
        private bool lastMinute;

        protected List<Karta> karte;

        public string PocetnaDestinacija { get { return this.pocetnaDestinacija; } }
        public string KrajnjaDestinacija { get { return this.krajnjaDestinacija; } }

        public Aranzman(string pocetnaDestinacija, string krajnjaDestinacija, int brNocenja, double cenaNocenja, bool lastMinute)
        {
            // TODO: Complete member initialization
            this.pocetnaDestinacija = pocetnaDestinacija;
            this.krajnjaDestinacija = krajnjaDestinacija;
            this.brNocenja = brNocenja;
            this.cenaNocenja = cenaNocenja;
            this.lastMinute = lastMinute;
        }

        public void dodajKarte(List<Karta> lk)
        {
            if (this.pocetnaDestinacija != lk.First().PocetnaDestinacija)
            {
                throw new GreskaAranzmana(lk.First(), "Pocetna destinacija prve karte je razlicita od pocetne destinacije aranzmana!");
            }

            if (this.krajnjaDestinacija != lk.Last().KrajnjaDestinacija)
            {
                throw new GreskaAranzmana(lk.Last(), "Krajnja destinacija poslednje karte je razlicita od krajnje destinacije aranzmana!");
            }

            this.karte = lk;
        }

        public double CenaAranzmana 
        { 
            get
            {
                double suma = 0;
                foreach (var item in karte)
                {
                    suma += item.dajCenuKArte();
                }

                return this.cenaNocenja * this.brNocenja + suma; 
            } 
        }



        public double Popust
        {
            get
            {
                double pop = 0;
                if (this.lastMinute)
                {
                    double suma = 0;
                    foreach (var item in karte)
                    {
                        if (item is AvionskaKarta)
                        {
                            suma += ((AvionskaKarta)item).Popust;
                        }
                        if (item is VoznaKarta)
                        {
                            suma += ((VoznaKarta)item).Popust;
                        }
                    }
                    pop = suma + this.cenaNocenja * this.brNocenja * 0.3;
                }

                return pop;
            }
        }

        public override string ToString()
        {
            string s;

            s = "Aranzman: " + this.pocetnaDestinacija + " - " + this.krajnjaDestinacija + " \n ";

            foreach (var item in karte)
            {
                s += item.ToString() + " \n ";
            }

            return s;
        }
    }
}
