﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Prvi
{
    class Putovanje : IPopust
    {
        private string pocetnaDestinacija;
        private string krajnjaDestinacija;

        protected List<Aranzman> aranzmani;


        public Putovanje(string pocetnaDestinacija, string krajnjaDestinacija)
        {
            // TODO: Complete member initialization
            this.pocetnaDestinacija = pocetnaDestinacija;
            this.krajnjaDestinacija = krajnjaDestinacija;
        }

        public void dodajAranzmane(List<Aranzman> la)
        {
            if (this.pocetnaDestinacija != la.First().PocetnaDestinacija)
            {
                throw new GreskaPutovanja(la.First(), "Pocetna destinacija prve karte je razlicita od pocetne destinacije putovanja!");
            }

            if (this.pocetnaDestinacija != la.Last().KrajnjaDestinacija)
            {
                throw new GreskaPutovanja(la.Last(), "Krajnja destinacija poslednje karte je razlicita od krajnje destinacije putovanja!");
            }

            this.aranzmani = la;
        }

        public double CenaPutovanja
        {
            get
            {
                double suma = 0;
                foreach (var item in this.aranzmani)
                {
                    suma += item.CenaAranzmana;
                }

                return suma;
            }
        }


        public double Popust
        {
            get
            {
                double suma = 0;
                foreach (var item in this.aranzmani)
                {
                    suma += item.Popust;
                }

                return suma;
            }
        }

        public override string ToString()
        {
            string s;

            s = "Putovanje: " + this.pocetnaDestinacija + " -> " + this.krajnjaDestinacija + " \n ";

            foreach (var item in this.aranzmani)
            {
                s += item.ToString() + " \n ";
            }

            return s;
        }
    }
}
