﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ConsoleApplication1
{
    public class Aranzman : IPopust
    {
        private string pocetnaDestinacija;

        public string PocetnaDestinacija
        {
            get { return pocetnaDestinacija; }
        }
        private string krajnjaDestinacija;

        public string KrajnjaDestinacija
        {
            get { return krajnjaDestinacija; }
        }
        private bool lastMinute;
        private int brojNocenja;
        private double cenaNocenja;

        protected List<Karta> lista;

        public Aranzman(string pocetnaDestinacija, string krajnjaDestinacija, bool lastMinute, int brojNocenja, double cenaNocenja)
        {
            this.pocetnaDestinacija = pocetnaDestinacija;
            this.krajnjaDestinacija = krajnjaDestinacija;
            this.lastMinute = lastMinute;
            this.brojNocenja = brojNocenja;
            this.cenaNocenja = cenaNocenja;

        }

        public void dodajKarte(List<Karta> karte)
        {
            Karta k,p;
            k = karte.FirstOrDefault();
            p = karte.LastOrDefault();

            if (k.PocetnaDestinacija != pocetnaDestinacija)
            {
                GreskaAranzmana g = new GreskaAranzmana(k, "Ne poklapaju se karte");
                g.ToString();
                return;
            }

            if (p.PocetnaDestinacija != pocetnaDestinacija)
            {
                GreskaAranzmana g = new GreskaAranzmana(p, "Ne poklapaju se karte");
                g.ToString();
                return;
            }

            this.lista = new List<Karta>(karte);
        }

        public double cenaAranzmana()
        {
            double suma = 0;

            suma = cenaNocenja * brojNocenja;

            foreach (Karta item in lista)
            {
                suma += item.dajCenu();
            }

            return suma;
        }

        public double Popust
        {
            get
            {

                if (lastMinute)
                    return cenaAranzmana() * 0.3;
                else
                    return cenaAranzmana();
            }
        }

        public override string ToString()
        {
            string s = "Aranzman:" + pocetnaDestinacija + "- " + krajnjaDestinacija + "\n";

            if(lista != null)
            foreach (Karta item in lista)
            {
                s += item.ToString() + "\n";
            }

            return s;
        }


    }
}
