﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace I
{
    public class Putovanje : IPopust
    {
        private string pocetnaDestinacija;
        private string krajnjaDestinacija;
        public Putovanje(string pocetnaDestinacija, string krajnjaDestinacija)
        {
            this.pocetnaDestinacija = pocetnaDestinacija;
            this.krajnjaDestinacija = krajnjaDestinacija;
        }
        protected List<Aranzman> aranzmani;
        public void dodajAranzmane(List<Aranzman> aranzmani)
        {
            if (!(pocetnaDestinacija.Equals(aranzmani[0]))) throw new GreskaPutovanja(aranzmani[0], "Ne poklapa se pocetna destinacija aranzmana!");
            else if (!(krajnjaDestinacija.Equals(aranzmani[0]))) throw new GreskaPutovanja(aranzmani[0], "Ne poklapa se krajnja destinacija aranzmana!");
            else this.aranzmani = aranzmani;
        }
        public double Vrednost
        {
            get
            {
                double suma = 0;
                foreach (Aranzman a in aranzmani)
                {
                    suma += a.Vrednost;
                }
                return suma;
            }
        }

        public double CenaPutovanja
        {
            get
            {
                double cena = 0;
                foreach (Aranzman a in aranzmani)
                {
                    cena += a.CenaAranzmana;
                }
                return cena;
            }

        }

       
        public override string ToString()
        {
            string s = "";
            s += "Putovanje:" + pocetnaDestinacija + "->" + krajnjaDestinacija+"\n";
            foreach (Aranzman a in aranzmani)
            {
                s += a.ToString() + "\n";
                
            }
            return s;
        }

    }
}
