﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace IPopravni
{
    public class Putovanje:IPopust
    {
        private string pocetnaDestinacija;
        private string krajnjaDestinacija;
        protected List<Aranzman> listaAranzmana;

        public Putovanje(string pocetak, string kraj)
        {
            this.pocetnaDestinacija = pocetak;
            this.krajnjaDestinacija = kraj;
            listaAranzmana = new List<Aranzman>();
        }

        public void dodajAranzmane(List<Aranzman> x)
        {
            if (x.First().PocetnaDestinacija != this.pocetnaDestinacija)
                throw new GreskaPutovanja(x.First(), "Pocetna destinacija se ne poklapa");
            else if (this.krajnjaDestinacija != x.Last().PocetnaDestinacija)
                throw new GreskaPutovanja(x.Last(), "Krajnje destinacije se ne poklapaju");
            else
            {
                foreach (Aranzman item in x)
                {
                    listaAranzmana.Add(item);
                }
            }
        }

        public double CenaPutovanja { get { return CenaPutovanja; }
            set
            {
                double suma = 0;
                foreach (Aranzman item in listaAranzmana)
                {
                    suma += item.CenaAranzmana;
                }
                CenaPutovanja = suma;
            }
        }

        public double Popust
        {
            get
            {
                return Popust;
            }
            set
            {
                double suma = 0;

                foreach (Aranzman item in listaAranzmana)
                {
                    suma += item.Popust;
                }

                Popust = suma;
            }
        }

        public override string ToString()
        {
            String s = "Putovanje: " + this.pocetnaDestinacija + "-" + this.krajnjaDestinacija;
            String x = "";
            foreach (Aranzman item in listaAranzmana)
            {
                x += item.ToString();
            }

            String a = s + " " + x;

            return a;
        }
    }
}
