﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ConsoleApplication1
{
    public class Aranzman : IPopust
    {
        private string pocetnaDestinacija;
        private string krajnjaDestinacija;
        private bool lastMinute;
        private int brojNocenja;
        private double cenaNocenja;
        protected List<Karta> karte;

        public string PocetnaDestinacija
        {
            get
            {
                return pocetnaDestinacija;
            }
        }

        public string KrajnjaDestinacija
        {
            get
            {
                return krajnjaDestinacija;
            }
        }

        public Aranzman(string poc, string kraj, int br, double cena, bool lm)
        {

            pocetnaDestinacija = poc;
            krajnjaDestinacija = kraj;
            lastMinute = lm;
            brojNocenja = br;
            cenaNocenja = cena;
            karte = new List<Karta>();
        }
        public void dodajKarte(List<Karta> ls)
        {
            if (!ls.First().PocetnaDestinacija.Equals(pocetnaDestinacija))
                throw new GreskaAranzmana(ls.First(), "Ne poklapaju se pocetna mesta");
            if (!ls.Last().KrajnjaDestinacija.Equals(krajnjaDestinacija))
            {
                throw new GreskaAranzmana(ls.Last(), "Ne poklapaju se krajnja mesta");
            }
            foreach (Karta item in ls)
            {
                karte.Add(item);
            }
        }

        public double CenaAranzmana
        {
            get
            {

                double ret = 0.0;
                ret = cenaNocenja * brojNocenja;
                foreach (Karta item in karte)
                {
                    ret += item.DajCenuKarte();
                }
                return ret;
            }
        }

        public double Popust
        {
            get 
            { 
                double ret = 0.0;
                if (lastMinute == true)
                    ret = (cenaNocenja * brojNocenja) * 0.3;
                foreach(Karta item in karte)
                {
                    if (item is AvionskaKarta)
                        ret += ((AvionskaKarta)item).Popust;
                    else if (item is VoznaKarta)
                        ret += ((VoznaKarta)item).Popust;
                }
                return ret;
            }
        }

        public override string ToString()
        {
            string str;
            str = "Aranzman: " + pocetnaDestinacija + " - " + krajnjaDestinacija;
            foreach (Karta item in karte)
            {
                str += "\n" + item.ToString();
            }
            return str;
        }
    }
}
