﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ConsoleApplication1
{
    public class Putovanje : IPopust
    {
        private string pocetnaDestinacija;
        private string krajnjaDestinacija;

        protected List<Aranzman> aranzmani;

        public Putovanje(string poc, string kra)
        {
            aranzmani = new List<Aranzman>();
            pocetnaDestinacija = poc;
            krajnjaDestinacija = kra;
        }

        public void dodajAranzmane(List<Aranzman> ls)
        {
            if (!ls.First().PocetnaDestinacija.Equals(pocetnaDestinacija))
            {
                throw new GreskaPutovanja(ls.First(), "Pocetni arazman i mesto se razlikuju");            
            }
            else if (!ls.Last().PocetnaDestinacija.Equals(krajnjaDestinacija))
            {
                throw new GreskaPutovanja(ls.Last(), "Krajnji aranzman i mesto se razlikuju");
            }
            else
            {
                foreach (Aranzman item in ls)
                {
                    aranzmani.Add(item);
                }
            }
        }
        public double CenaPutovanja
        {
            get
            {
                double ret = 0.0;
                foreach (Aranzman item in aranzmani)
                {
                    ret += item.CenaAranzmana;
                }
                return ret;
            }
        }



        public double Popust
        {
            get 
            {
                double ret = 0.0;
                foreach (Aranzman item in aranzmani)
                    ret += item.Popust;
                return ret;
            }
        }

        public override string ToString()
        {
            string str;
            str = "Putovanje: ";
            foreach (Aranzman item in aranzmani)
            {
                str += "\n" + item.ToString();
            }
            return str;
        }


    }
}
